#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 3

## the next line selects the memory size
#SBATCH --mem=32G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1

cat << EOF > temp.sh
#!/bin/bash

source ~/.bashrc
conda activate fnet
python evaluate.py test
EOF

singularity exec -B /images --nv /containers/images/u1604-cuda-9.1.img bash ./temp.sh
rm -fv temp.sh

