#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd
#SBATCH -J array
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 3

## the next line selects the memory size
#SBATCH --mem=16G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1
#SBATCH -a 0-11

input=(alpha_tubulin beta_actin desmoplakin dna fibrillarin lamin_b1 myosin_iib sec61_beta st6gal1 tom20 zo1)
cat << EOF > temp_${input[$SLURM_ARRAY_TASK_ID]}.sh
#!/bin/bash

source ~/.bashrc
conda activate fnet
bash ./scripts/predict_membrane_channel.sh ${input[$SLURM_ARRAY_TASK_ID]} 0
EOF

singularity exec -B /images --nv /containers/images/u1604-cuda-9.1.img bash ./temp_${input[$SLURM_ARRAY_TASK_ID]}.sh
rm -fv temp_${input[$SLURM_ARRAY_TASK_ID]}.sh

