#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd

## the nex line selects the job array
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 3

## the next line selects the memory size
#SBATCH --mem=16G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1


cat << EOF > temp_membrane_rerun.sh
#!/bin/bash

source ~/.bashrc
conda activate fnet
bash ./scripts/train_membrane_caax_63x.sh 0
EOF

singularity exec -B /images --nv /containers/images/u1604-cuda-9.1.img bash ./temp_membrane_rerun.sh
rm -fv temp_membrane_rerun.sh

