#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd
#SBATCH -J eval_greedy
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 3

## the next line selects the memory size
#SBATCH --mem=32G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1
#SBATCH -a 0-11
cat << EOF > temp_eval_${SLURM_ARRAY_TASK_ID}.sh
#!/bin/bash
source ~/.bashrc
conda activate fnet
HOME_DIR=`pwd`
organelle=zo1
TRAIN_OR_TEST=train
time python evaluate_greedy.py $TRAIN_OR_TEST ${organelle} $SLURM_ARRAY_TASK_ID $HOME_DIR
EOF

singularity exec -B /images --nv /containers/images/u1604-cuda-9.1.img bash ./temp_eval_${SLURM_ARRAY_TASK_ID}.sh
rm -fv temp_eval_${SLURM_ARRAY_TASK_ID}.sh

