#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd
#SBATCH -J pred_eval
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 1

## the next line selects the memory size
#SBATCH --mem=30G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1
#SBATCH -a 0-11

cat << EOF > temp_predict_${SLURM_ARRAY_TASK_ID}.sh
#!/bin/bash
source ~/.bashrc
conda activate fnet
organelle=zo1
time bash ./scripts/predict_eval_greedy.sh ${organelle} $SLURM_ARRAY_TASK_ID 0
EOF
                
singularity exec --nv /containers/images/u1604-cuda-9.1.img bash ./temp_predict_${SLURM_ARRAY_TASK_ID}.sh
rm -fv temp_predict_${SLURM_ARRAY_TASK_ID}.sh



