#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd
#SBATCH -J pred_optimal
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 1

## the next line selects the memory size
#SBATCH --mem=30G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1
#SBATCH -a 1
model=zo1
cat << EOF > temp_pred_opt_${model}_${SLURM_ARRAY_TASK_ID}.sh
#!/bin/bash
source ~/.bashrc
conda activate fnet
time bash ./scripts/predict_optimal_param.sh ${model} $SLURM_ARRAY_TASK_ID 0
EOF
                
singularity exec --nv /containers/images/u1604-cuda-9.1.img bash ./temp_pred_opt_${model}_${SLURM_ARRAY_TASK_ID}.sh
rm -fv temp_pred_opt_${model}_${SLURM_ARRAY_TASK_ID}.sh



