#!/bin/bash
#
#$ -j y
#$ -S /bin/bash
#$ -cwd
#SBATCH -J train_greedy
## the next line selects the partition/queue
#SBATCH -p gpu2

## the next line selects the number of CPUs
#SBATCH -n 1

## the next line selects the memory size
#SBATCH --mem=60G

## the next line selects the walltime
#SBATCH -t 12:00:00

## the next line selects the walltime
#SBATCH --gres=gpu:1
#SBATCH -a 0-11
input=(0.0 0.1 0.3 0.5 0.7 1.0 1.3 1.7 2.2 2.8 3.4 4.0)  
cat << EOF > temp_train_${SLURM_ARRAY_TASK_ID}.sh
#!/bin/bash

source ~/.bashrc
conda activate fnet
model=zo1
time bash ./scripts/my_train_greedy.sh ${model} 112500 ${input[$SLURM_ARRAY_TASK_ID]} $SLURM_ARRAY_TASK_ID 0
EOF

singularity exec --nv /containers/images/u1604-cuda-9.1.img bash ./temp_train_${SLURM_ARRAY_TASK_ID}.sh
rm -rf temp_train_${SLURM_ARRAY_TASK_ID}.sh
