% slml2report('desmo_2nd/model.mat', 'desmo_original/model.mat')
clear all

if exist('./report', 'dir')
    rmdir('./report', 's')
end
mkdir('./report');

fileID = fopen('./index.html', 'w');
html_init(fileID);
options = {};
% init options using ml_initparam
options = ml_initparam(options, struct('verbose', true, 'includenuclear', false, ...
    'includecell', false, 'includeprot', true));
classlabels = 'SPHARM';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT MODEL PATHS
load( 'desmo_1st/model.mat', 'model' ); models{1} = model; clear model;
load( 'desmo_2nd/model.mat', 'model' ); models{2} = model; clear model;
% load( 'mito_1st/model.mat', 'model' ); models{3} = model; clear model;
% load( 'mito_2nd/model.mat', 'model' ); models{4} = model; clear model;
load( 'desmo_original/model.mat', 'model' ); models{3} = model; clear model; % always put the groundtruth models at last
models2report_v2(models, options, classlabels, fileID);
html_close(fileID);
fclose(fileID);

if exist([pwd filesep 'index.html'], 'file')
    movefile([pwd filesep 'index.html'], [pwd filesep 'report']);
end

image_info = dir('*.png');
image_names = {image_info.name};
for i = 1:length(image_names)
    movefile(image_names{i}, ['report' filesep image_names{i}]);
end

close all